// #autoload
// #category = AgentABC's Scripts
// #name = ABC AutoDemo
// #version = 1.0b
// #date = Nov 2, 2002
// #warrior = AgentABC
// #email = agentabc11@hotmail.com
// #web = http://scripts.tribalwar.com/agent
// #description = Automaticly Demos stuff for you.  There is also in-game demo naming!
// #status = beta
// #credit = Nightmare

function AutoDemoLoadPrefs() {
    $AutoDemo:CanRecord = true;
    $AutoDemo:CanOveride = true;
    if(isFile("prefs/DemoPrefs.cs.cs") && !$AutoDemoPrefsLoaded) {
	   exec("prefs/DemoPrefs.cs");
       $AutoDemoPrefsLoaded = true;
    }
    else {
       $AutoDemo::Enabled = 1;
       export("$AutoDemo::*", "prefs/DemoPrefs.cs", false);
       $AutodemoPrefsLoaded = true;
    }
}

package AutoDemo {
  function stopRecord() {
     if(isRecordingDemo()) {
         $AutoDemo:CanRecord = true;
         parent::stopRecord();
     }
  }
  function StopDemoRecord() {
      if(isRecordingDemo()) {
         stopRecord();
      }
      else if($AutoDemo:CanOveride) {
         $AutoDemo:CanOveride = false;
         cancel($AutoDemo:schedule);
         AutoDemoDisplay(true, "<color:00ff00>DemoRecord has been <color:EB0606>Cancelled", 7000);
      }
   }
   // binds and what not
   function OptionsDlg::onWake(%this) {
      if(!$AutoDemoBinds) {
		 $RemapName[$RemapCount]="\c4AutoDemo Toggle";
         $RemapCmd[$RemapCount]="AutoDemoToggle";
		 $RemapCount++;
         $RemapName[$RemapCount]="\c4AutoDemo CustomName";
         $RemapCmd[$RemapCount]="AutoDemoCustomName";
		 $RemapCount++;
      }
      $AutoDemoBinds = true;
	  parent::onWake(%this);
   }
   function AutoDemoToggle(%val) {
      if(%val) {
         $AutoDemo::Enabled = !$AutoDemo::Enabled;
         %message = $AutoDemo::Enabled ? "Enabled" : "Disabled";
         addMessageHudLine("\c2AutoDemo now" SPC %message);
         export("$AutoDemo::*", "prefs/DemoPrefs.cs", false);
      }
   }
   // Events And such
   function DispatchLaunchMode() {
      addMessageCallback('MsgGameOver', AutoDemoGameOver);
      addMessageCallback('MsgMissionStart', AutoDemoMatchStart);
      addMessageCallback('MsgClientJoin', AutoDemoInfoJoin);
      addMessageCallback('MsgLoadInfo', AutoDemoInfoMissionLoad);
      parent::DispatchLaunchMode();
   }
   function AutoDemoInfoJoin(%msgType, %msg, %clientName, %clientID, %targetID, %bot, %Admin, %SuperAdmin, %Smurf, %Guid) {
	  if( Strstr(%msg, "Welcome to Tribes2") != -1 ) {
		  $currentName	 = detag(%clientName);
	      $currentClientID = %clientID;
	  }
   }
   function AutoDemoInfoMissionLoad(%msgType, %msg, %bitmapName, %mapName, %missionType) {
	  $currentMapName = detag(%mapName);
	  $currentMapType = detag(%missionType);
   }
   function AutoDemoGameOver( %msgType, %msg ) {
      if($AutoDemo::Enabled) {
         $AutoDemo:CanOveride = true;
         stopDemoRecord();
      }
   }
   function AutoDemoMatchStart( %msgType, %msg ) {
      if(strstr( %msg, "Match starts in 15 seconds" ) != -1 && $AutoDemo::Enabled) {
         AutoDemoUpdate(15);
      }
   }
   function AutoDemoUpdate(%seconds) {
      if(%seconds > 0 && $AutoDemo:CanOveride) {
         %stat0 = (%statStr0 = getKey(movemap, AutoDemoCustomName)) !$= "";
         %stat1 = (%statStr1 = getKey(movemap, stopRecordingDemo)) !$= "";
         %displayStr = "<just:center><color:00ff00>Demo Recording starts in <color:f1f1f1>" SPC %seconds SPC "<color:00ff00>seconds\n";
         %keyStr0 = %stat0 ? " [<color:EB0606>" @ %statStr[0] @ "<color:00ff00>] to Name it" : "";
         %keyStr1 = %stat1 ? " [<color:EB0606>" @ %statStr[1] @ "<color:00ff00>] to Cancel" : "";
         %displayStr = %displayStr @ %keyStr0 @ %keyStr1;
         AutoDemoDisplay(true, %displayStr, 2000);
         $AutoDemo:CanOveride = true;
         $AutoDemo:schedule = schedule(1000, 0, AutoDemoUpdate, %seconds-1);
      }
      else {
         AutoDemoAutoRecord();
      }
   }
   function AutoDemoCustomName() {
      if(!isRecordingDemo() && $Autodemo:CanRecord) {
         cancel($AutoDemo:schedule);
         $AutoDemo:CanOveride = false;
         %filename = TextInputGUI.call("Demo Name", "Input a custom name for the demo", "AutoDemoItsNamed");
      }
   }
   function AutoDemoItsNamed(%filename) {
      %file = "recordings/" @ %filename @ ".rec";
      addMessageHudLine( "\c3Recording Demo: [\c2" @ %filename @ "\c3].");
      startRecord(%file);
   }
   function AutoDemoAutoRecord() {
      if(!isRecordingDemo() && $Autodemo:CanRecord) {
         cancel($AutoDemo:schedule);
         $AutoDemo:CanOveride = false;
         %name = filterFileInput($currentName);
         %map = filterFileInput($currentMapName);
         while(%count++ < 10000) {
            %fileName = %name @ "_" @ %map @ "_" @ stringPadBefore( %count, 4, "0" );
            %file = "recordings/" @ %fileName @ ".rec";
            if(!isfile(%file)) {
              startRecord(%file);
              addMessageHudLine( "\c3Recording Demo: [\c2" @ %filename @ "\c3].");
              return;
            }
         }
      }
   }
};
activatePackage(AutoDemo);
AutoDemoLoadPrefs();

