// #autoload
// #hide
// #Author = Nightmare & AgentABC

if(isobject(TextInputGUI))
	TextInputGUI.delete();

// -----------------------------------------------------------------------------

new GuiControl(TextInputGUI) {
	profile = "DlgBackProfile";
	extent = "640 480";
	modal = "True";

	new ShellBitmapButton() {
		profile = "GuiHelpLineProfile";
		horizSizing = "width";
		vertSizing = "height";
		extent = "640 480";
		simpleStyle = "1";
		command = "TextInputGUI.send(true);";
	};
	new ShellPaneCtrl(TextInputWindow) {
		profile = "ShellWindowProfile";
		horizSizing = "center";
		vertSizing = "center";
		extent = "310 141";
		text = "";

		new ShellTextEditCtrl(TextInputInput) {
			profile = "NewTextEditProfile";
			position = "23 48";
			extent = "261 38";
			command = "TextInputGUI.checkNull();";
			accelerator = "enter";
		};
		new ShellBitmapButton(TextInputOK) {
			position = "22 88";
			extent = "170 38";
			text = "Done";
			command = "TextInputGUI.send();";
		};
		new ShellBitmapButton(TextInputCancel) {
			position = "187 88";
			extent = "97 38";
			text = "Cancel";
			command = "TextInputGUI.send(true);";
		};
		new GuiMLTextCtrl(TextInputText) {
			profile = "";
			position = "33 30";
			extent = "243 18";
			lineSpacing = "2";
		};
	};
};
function TextInputGUI::call(%this, %title, %text, %function) {
	TextInputWindow.setText(%title);
	TextInputText.setText(%text);
	TextInputInput.setValue("");

	%this.bind = new actionMap();
	%this.bind.bindCmd(keyboard, escape, "", "TextInputGUI.send(true);");
	%this.bind.bindCmd(keyboard, enter,  "", "TextInputGUI.send();");
	%this.bind.push();
    %this.func = %function;

	TextInputGUI.checkNull();

	canvas.pushdialog(TextInputGUI);
	canvas.repaint();

	%increase = getword(TextInputText.getExtent(), 1);

	TextInputWindow.setExtent( 310, 123 + %increase );
	TextInputInput.setPosition( 23, 30 + %increase );
	TextInputCancel.setPosition( 187, 70 + %increase);
	TextInputOK.setPosition( 22, 70 + %increase);

	TextInputGUI.position = "2 2";
}

function TextInputGUI::send(%this, %cancel) {
	if(TextInputInput.noNull && TextInputInput.getValue() $= "" && !%cancel) return;
	canvas.popdialog(TextInputGUI);
    %this.bind.pop();
	%this.bind.delete();
	%this.bind = "";
	if(!%cancel && %this.func !$= "") {
		eval(%this.func @ "(TextInputinput.getvalue());");
		%this.func = "";
	}
	else if(%cancel) {
		eval(%this.cancelFunc);
	}
}
function TextInputGUI::checkNull(%this) {
	%toggle = (TextInputInput.getValue() $= "" && TextInputInput.noNull) ? false : true;
	TextInputOK.setActive(%toggle);
}

// -----------------------------------------------------------------------------
function AutoDemoDisplayAdd() {
  if(!isobject(AutoDemoDisplay)) {
    error("ADDING GUI");
    new ShellFieldCtrl(AutoDemoDisplay) {
	  profile = "ShellFieldProfile";
	  horizSizing = "right";
	  vertSizing = "bottom";
	  position = "238 208";
	  extent = "210 100";
	  minExtent = "16 18";
	  visible = "0";
	  hideCursor = "0";
	  bypassHideCursor = "0";
	  helpTag = "0";

	new ShellFieldCtrl(AutoDemoDisplayBack) {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "1 1";
		extent = "207 96";
		minExtent = "16 18";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	};
	new GuiMLTextCtrl(AutoDemoDisplayText) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "2 2";
		extent = "200 95";
		minExtent = "8 8";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		lineSpacing = "2";
		allowColorChars = "0";
		maxChars = "-1";
	  };
    };
  }
  playgui.add(AutoDemoDisplay);
}
AutoDemoDisplayAdd();

function AutoDemoDisplay( %vis, %text, %time ) {
   if(%vis) {
      AutoDemoDisplay.visible = true;
      AutoDemoDisplayText.settext(%text);
      AutoDemoDisplay.DisplaySchedule = AutoDemoDisplay.schedule( %time, setVisible, false );
   }
   else {
      AutoDemoDisplay.visible = false;
      AutoDemoDisplayText.settext("");
      AutoDemoDisplay.DisplaySchedule = " ";
   }
}

